diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/routing/manet-routing-compare.cc ns-3.39/examples/routing/manet-routing-compare.cc
--- ns-3.38/examples/routing/manet-routing-compare.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/routing/manet-routing-compare.cc	2023-07-05 14:23:47.665426700 -0700
@@ -69,6 +69,7 @@
 #include "ns3/core-module.h"
 #include "ns3/dsdv-module.h"
 #include "ns3/dsr-module.h"
+#include "ns3/flow-monitor-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/mobility-module.h"
 #include "ns3/network-module.h"
@@ -94,20 +95,15 @@
     RoutingExperiment();
     /**
      * Run the experiment.
-     * \param nSinks The number of Sink Nodes.
-     * \param txp The Tx power.
-     * \param CSVfileName The output CSV filename.
      */
-    void Run(int nSinks, double txp, std::string CSVfileName);
-    // static void SetMACParam (ns3::NetDeviceContainer & devices,
-    //                                  int slotDistance);
+    void Run();
+
     /**
      * Handles the command-line parameters.
      * \param argc The argument count.
      * \param argv The argument vector.
-     * \return the CSV filename.
      */
-    std::string CommandSetup(int argc, char** argv);
+    void CommandSetup(int argc, char** argv);
 
   private:
     /**
@@ -127,25 +123,19 @@
      */
     void CheckThroughput();
 
-    uint32_t port;            //!< Receiving port number.
-    uint32_t bytesTotal;      //!< Total received bytes.
-    uint32_t packetsReceived; //!< Total received packets.
-
-    std::string m_CSVfileName;  //!< CSV filename.
-    int m_nSinks;               //!< Number of sink nodes.
-    std::string m_protocolName; //!< Protocol name.
-    double m_txp;               //!< Tx power.
-    bool m_traceMobility;       //!< Enavle mobility tracing.
-    uint32_t m_protocol;        //!< Protocol type.
+    uint32_t port{9};            //!< Receiving port number.
+    uint32_t bytesTotal{0};      //!< Total received bytes.
+    uint32_t packetsReceived{0}; //!< Total received packets.
+
+    std::string m_CSVfileName{"manet-routing.output.csv"}; //!< CSV filename.
+    int m_nSinks{10};                                      //!< Number of sink nodes.
+    std::string m_protocolName{"AODV"};                    //!< Protocol name.
+    double m_txp{7.5};                                     //!< Tx power.
+    bool m_traceMobility{false};                           //!< Enable mobility tracing.
+    bool m_flowMonitor{false};                             //!< Enable FlowMonitor.
 };
 
 RoutingExperiment::RoutingExperiment()
-    : port(9),
-      bytesTotal(0),
-      packetsReceived(0),
-      m_CSVfileName("manet-routing.output.csv"),
-      m_traceMobility(false),
-      m_protocol(2) // AODV
 {
 }
 
@@ -209,25 +199,42 @@
     return sink;
 }
 
-std::string
+void
 RoutingExperiment::CommandSetup(int argc, char** argv)
 {
     CommandLine cmd(__FILE__);
     cmd.AddValue("CSVfileName", "The name of the CSV output file name", m_CSVfileName);
     cmd.AddValue("traceMobility", "Enable mobility tracing", m_traceMobility);
-    cmd.AddValue("protocol", "1=OLSR;2=AODV;3=DSDV;4=DSR", m_protocol);
+    cmd.AddValue("protocol", "Routing protocol (OLSR, AODV, DSDV, DSR)", m_protocolName);
+    cmd.AddValue("flowMonitor", "enable FlowMonitor", m_flowMonitor);
     cmd.Parse(argc, argv);
-    return m_CSVfileName;
+
+    std::vector<std::string> allowedProtocols{"OLSR", "AODV", "DSDV", "DSR"};
+
+    if (std::find(std::begin(allowedProtocols), std::end(allowedProtocols), m_protocolName) ==
+        std::end(allowedProtocols))
+    {
+        NS_FATAL_ERROR("No such protocol:" << m_protocolName);
+    }
 }
 
 int
 main(int argc, char* argv[])
 {
     RoutingExperiment experiment;
-    std::string CSVfileName = experiment.CommandSetup(argc, argv);
+    experiment.CommandSetup(argc, argv);
+    experiment.Run();
+
+    return 0;
+}
+
+void
+RoutingExperiment::Run()
+{
+    Packet::EnablePrinting();
 
     // blank out the last output file and write the column headers
-    std::ofstream out(CSVfileName);
+    std::ofstream out(m_CSVfileName);
     out << "SimulationSecond,"
         << "ReceiveRate,"
         << "PacketsReceived,"
@@ -236,22 +243,6 @@
         << "TransmissionPower" << std::endl;
     out.close();
 
-    int nSinks = 10;
-    double txp = 7.5;
-
-    experiment.Run(nSinks, txp, CSVfileName);
-
-    return 0;
-}
-
-void
-RoutingExperiment::Run(int nSinks, double txp, std::string CSVfileName)
-{
-    Packet::EnablePrinting();
-    m_nSinks = nSinks;
-    m_txp = txp;
-    m_CSVfileName = CSVfileName;
-
     int nWifis = 50;
 
     double TotalTime = 200.0;
@@ -260,7 +251,6 @@
     std::string tr_name("manet-routing-compare");
     int nodeSpeed = 20; // in m/s
     int nodePause = 0;  // in s
-    m_protocolName = "protocol";
 
     Config::SetDefault("ns3::OnOffApplication::PacketSize", StringValue("64"));
     Config::SetDefault("ns3::OnOffApplication::DataRate", StringValue(rate));
@@ -289,8 +279,8 @@
                                  "ControlMode",
                                  StringValue(phyMode));
 
-    wifiPhy.Set("TxPowerStart", DoubleValue(txp));
-    wifiPhy.Set("TxPowerEnd", DoubleValue(txp));
+    wifiPhy.Set("TxPowerStart", DoubleValue(m_txp));
+    wifiPhy.Set("TxPowerEnd", DoubleValue(m_txp));
 
     wifiMac.SetType("ns3::AdhocWifiMac");
     NetDeviceContainer adhocDevices = wifi.Install(wifiPhy, wifiMac, adhocNodes);
@@ -329,36 +319,36 @@
     Ipv4ListRoutingHelper list;
     InternetStackHelper internet;
 
-    switch (m_protocol)
+    if (m_protocolName == "OLSR")
     {
-    case 1:
         list.Add(olsr, 100);
-        m_protocolName = "OLSR";
-        break;
-    case 2:
+        internet.SetRoutingHelper(list);
+        internet.Install(adhocNodes);
+    }
+    else if (m_protocolName == "AODV")
+    {
         list.Add(aodv, 100);
-        m_protocolName = "AODV";
-        break;
-    case 3:
-        list.Add(dsdv, 100);
-        m_protocolName = "DSDV";
-        break;
-    case 4:
-        m_protocolName = "DSR";
-        break;
-    default:
-        NS_FATAL_ERROR("No such protocol:" << m_protocol);
+        internet.SetRoutingHelper(list);
+        internet.Install(adhocNodes);
     }
-
-    if (m_protocol < 4)
+    else if (m_protocolName == "DSDV")
     {
+        list.Add(dsdv, 100);
         internet.SetRoutingHelper(list);
         internet.Install(adhocNodes);
     }
-    else if (m_protocol == 4)
+    else if (m_protocolName == "DSR")
     {
         internet.Install(adhocNodes);
         dsrMain.Install(dsr, adhocNodes);
+        if (m_flowMonitor)
+        {
+            NS_FATAL_ERROR("Error: FlowMonitor does not work with DSR. Terminating.");
+        }
+    }
+    else
+    {
+        NS_FATAL_ERROR("No such protocol:" << m_protocolName);
     }
 
     NS_LOG_INFO("assigning ip address");
@@ -372,7 +362,7 @@
     onoff1.SetAttribute("OnTime", StringValue("ns3::ConstantRandomVariable[Constant=1.0]"));
     onoff1.SetAttribute("OffTime", StringValue("ns3::ConstantRandomVariable[Constant=0.0]"));
 
-    for (int i = 0; i < nSinks; i++)
+    for (int i = 0; i < m_nSinks; i++)
     {
         Ptr<Socket> sink = SetupPacketReceive(adhocInterfaces.GetAddress(i), adhocNodes.Get(i));
 
@@ -380,7 +370,7 @@
         onoff1.SetAttribute("Remote", remoteAddress);
 
         Ptr<UniformRandomVariable> var = CreateObject<UniformRandomVariable>();
-        ApplicationContainer temp = onoff1.Install(adhocNodes.Get(i + nSinks));
+        ApplicationContainer temp = onoff1.Install(adhocNodes.Get(i + m_nSinks));
         temp.Start(Seconds(var->GetValue(100.0, 101.0)));
         temp.Stop(Seconds(TotalTime));
     }
@@ -411,9 +401,12 @@
     AsciiTraceHelper ascii;
     MobilityHelper::EnableAsciiAll(ascii.CreateFileStream(tr_name + ".mob"));
 
-    // Ptr<FlowMonitor> flowmon;
-    // FlowMonitorHelper flowmonHelper;
-    // flowmon = flowmonHelper.InstallAll();
+    FlowMonitorHelper flowmonHelper;
+    Ptr<FlowMonitor> flowmon;
+    if (m_flowMonitor)
+    {
+        flowmon = flowmonHelper.InstallAll();
+    }
 
     NS_LOG_INFO("Run Simulation.");
 
@@ -422,7 +415,10 @@
     Simulator::Stop(Seconds(TotalTime));
     Simulator::Run();
 
-    // flowmon->SerializeToXmlFile(tr_name + ".flowmon", false, false);
+    if (m_flowMonitor)
+    {
+        flowmon->SerializeToXmlFile(tr_name + ".flowmon", false, false);
+    }
 
     Simulator::Destroy();
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/socket/socket-options-ipv4.cc ns-3.39/examples/socket/socket-options-ipv4.cc
--- ns-3.38/examples/socket/socket-options-ipv4.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/socket/socket-options-ipv4.cc	2023-07-05 14:23:47.665426700 -0700
@@ -22,7 +22,6 @@
 //
 // - UDP flows from n0 to n1
 
-#include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/socket/socket-options-ipv6.cc ns-3.39/examples/socket/socket-options-ipv6.cc
--- ns-3.38/examples/socket/socket-options-ipv6.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/socket/socket-options-ipv6.cc	2023-07-05 14:23:47.665426700 -0700
@@ -22,7 +22,6 @@
 //
 // - UDP flows from n0 to n1
 
-#include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/stats/examples-to-run.py ns-3.39/examples/stats/examples-to-run.py
--- ns-3.38/examples/stats/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/stats/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tcp/dctcp-example.cc ns-3.39/examples/tcp/dctcp-example.cc
--- ns-3.38/examples/tcp/dctcp-example.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tcp/dctcp-example.cc	2023-07-05 14:23:47.665426700 -0700
@@ -301,8 +301,6 @@
     Time startTime = Seconds(0);
     Time stopTime = flowStartupWindow + convergenceTime + measurementWindow;
 
-    Time clientStartTime = startTime;
-
     rxS1R1Bytes.reserve(10);
     rxS2R2Bytes.reserve(20);
     rxS3R1Bytes.reserve(10);
@@ -493,7 +491,7 @@
         AddressValue remoteAddress(InetSocketAddress(ipR2T2[i].GetAddress(0), port));
         clientHelper1.SetAttribute("Remote", remoteAddress);
         clientApps1.Add(clientHelper1.Install(S2.Get(i)));
-        clientApps1.Start(i * flowStartupWindow / 20 + clientStartTime + MilliSeconds(i * 5));
+        clientApps1.Start(i * flowStartupWindow / 20 + startTime + MilliSeconds(i * 5));
         clientApps1.Stop(stopTime);
     }
 
@@ -534,13 +532,12 @@
         if (i < 10)
         {
             clientApps1.Add(clientHelper1.Install(S1.Get(i)));
-            clientApps1.Start(i * flowStartupWindow / 10 + clientStartTime + MilliSeconds(i * 5));
+            clientApps1.Start(i * flowStartupWindow / 10 + startTime + MilliSeconds(i * 5));
         }
         else
         {
             clientApps1.Add(clientHelper1.Install(S3.Get(i - 10)));
-            clientApps1.Start((i - 10) * flowStartupWindow / 10 + clientStartTime +
-                              MilliSeconds(i * 5));
+            clientApps1.Start((i - 10) * flowStartupWindow / 10 + startTime + MilliSeconds(i * 5));
         }
 
         clientApps1.Stop(stopTime);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tcp/examples-to-run.py ns-3.39/examples/tcp/examples-to-run.py
--- ns-3.38/examples/tcp/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tcp/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tcp/tcp-validation.cc ns-3.39/examples/tcp/tcp-validation.cc
--- ns-3.38/examples/tcp/tcp-validation.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tcp/tcp-validation.cc	2023-07-05 14:23:47.665426700 -0700
@@ -746,7 +746,7 @@
         firstTcpTypeId = TcpDctcp::GetTypeId();
         Config::SetDefault("ns3::CoDelQueueDisc::CeThreshold", TimeValue(ceThreshold));
         Config::SetDefault("ns3::FqCoDelQueueDisc::CeThreshold", TimeValue(ceThreshold));
-        if (queueUseEcn == false)
+        if (!queueUseEcn)
         {
             std::cout << "Warning: using DCTCP with queue ECN disabled" << std::endl;
         }
@@ -933,7 +933,7 @@
         proto->SetAttribute("SocketType", TypeIdValue(secondTcpTypeId));
     }
 
-    // InternetStackHelper will install a base TrafficControLayer on the node,
+    // InternetStackHelper will install a base TrafficControlLayer on the node,
     // but the Ipv4AddressHelper below will install the default FqCoDelQueueDisc
     // on all single device nodes.  The below code overrides the configuration
     // that is normally done by the Ipv4AddressHelper::Install() method by
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tcp/tcp-variants-comparison.cc ns-3.39/examples/tcp/tcp-variants-comparison.cc
--- ns-3.38/examples/tcp/tcp-variants-comparison.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tcp/tcp-variants-comparison.cc	2023-07-05 14:23:47.665426700 -0700
@@ -79,8 +79,8 @@
 static uint32_t
 GetNodeIdFromContext(std::string context)
 {
-    std::size_t const n1 = context.find_first_of('/', 1);
-    std::size_t const n2 = context.find_first_of('/', n1 + 1);
+    const std::size_t n1 = context.find_first_of('/', 1);
+    const std::size_t n2 = context.find_first_of('/', n1 + 1);
     return std::stoul(context.substr(n1 + 1, n2 - n1 - 1));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/traffic-control/examples-to-run.py ns-3.39/examples/traffic-control/examples-to-run.py
--- ns-3.38/examples/traffic-control/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/traffic-control/examples-to-run.py	2023-07-05 14:23:47.665426700 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tutorial/examples-to-run.py ns-3.39/examples/tutorial/examples-to-run.py
--- ns-3.38/examples/tutorial/examples-to-run.py	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tutorial/examples-to-run.py	2023-07-05 14:23:47.669427000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/tutorial/seventh.cc ns-3.39/examples/tutorial/seventh.cc
--- ns-3.38/examples/tutorial/seventh.cc	2023-03-16 20:54:23.568868400 -0700
+++ ns-3.39/examples/tutorial/seventh.cc	2023-07-05 14:23:47.669427000 -0700
@@ -125,7 +125,7 @@
     Address anyAddress;
     std::string probeType;
     std::string tracePath;
-    if (useV6 == false)
+    if (!useV6)
     {
         Ipv4AddressHelper address;
         address.SetBase("10.1.1.0", "255.255.255.0");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/udp/examples-to-run.py ns-3.39/examples/udp/examples-to-run.py
--- ns-3.38/examples/udp/examples-to-run.py	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/udp/examples-to-run.py	2023-07-05 14:23:47.669427000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/udp/udp-echo.cc ns-3.39/examples/udp/udp-echo.cc
--- ns-3.38/examples/udp/udp-echo.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/udp/udp-echo.cc	2023-07-05 14:23:47.669427000 -0700
@@ -81,7 +81,7 @@
     // We've got the "hardware" in place.  Now we need to add IP addresses.
     //
     NS_LOG_INFO("Assign IP Addresses.");
-    if (useV6 == false)
+    if (!useV6)
     {
         Ipv4AddressHelper ipv4;
         ipv4.SetBase("10.1.1.0", "255.255.255.0");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/udp-client-server/udp-client-server.cc ns-3.39/examples/udp-client-server/udp-client-server.cc
--- ns-3.38/examples/udp-client-server/udp-client-server.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/udp-client-server/udp-client-server.cc	2023-07-05 14:23:47.669427000 -0700
@@ -74,7 +74,7 @@
     NetDeviceContainer d = csma.Install(n);
 
     NS_LOG_INFO("Assign IP Addresses.");
-    if (useV6 == false)
+    if (!useV6)
     {
         Ipv4AddressHelper ipv4;
         ipv4.SetBase("10.1.1.0", "255.255.255.0");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/udp-client-server/udp-trace-client-server.cc ns-3.39/examples/udp-client-server/udp-trace-client-server.cc
--- ns-3.38/examples/udp-client-server/udp-trace-client-server.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/udp-client-server/udp-trace-client-server.cc	2023-07-05 14:23:47.669427000 -0700
@@ -73,7 +73,7 @@
     NetDeviceContainer d = csma.Install(n);
 
     NS_LOG_INFO("Assign IP Addresses.");
-    if (useV6 == false)
+    if (!useV6)
     {
         Ipv4AddressHelper ipv4;
         ipv4.SetBase("10.1.1.0", "255.255.255.0");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/examples-to-run.py ns-3.39/examples/wireless/examples-to-run.py
--- ns-3.38/examples/wireless/examples-to-run.py	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/examples-to-run.py	2023-07-05 14:23:47.669427000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
@@ -30,6 +29,9 @@
     ("wifi-power-adaptation-distance --manager=ns3::ParfWifiManager --outputFileName=parf --steps=5 --stepsSize=10", "True", "True"),
     ("wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf --steps=5 --stepsSize=10", "True", "False"),
     ("wifi-power-adaptation-distance --manager=ns3::RrpaaWifiManager --outputFileName=rrpaa --steps=5 --stepsSize=10", "True", "False"),
+    ("wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1", "True", "False"),
+    ("wifi-rate-adaptation-distance --standard=802.11a --staManager=ns3::MinstrelWifiManager --apManager=ns3::MinstrelWifiManager --outputFileName=minstrel --stepsSize=50 --stepsTime=0.1 --STA1_x=-200", "True", "False"),
+    ("wifi-rate-adaptation-distance --staManager=ns3::MinstrelHtWifiManager --apManager=ns3::MinstrelHtWifiManager --outputFileName=minstrelHt --shortGuardInterval=true --channelWidth=40 --stepsSize=50 --stepsTime=0.1", "True", "False"),
     ("wifi-power-adaptation-interference --simuTime=5", "True", "False"),
     ("wifi-dsss-validation", "True", "True"),
     ("wifi-ofdm-validation", "True", "True"),
@@ -58,7 +60,7 @@
     ("wifi-eht-network --simulationTime=0.1 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=547", "True", "True"),
     ("wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=0 --useExtendedBlockAck=1 --frequency2=5 --minExpectedThroughput=12 --maxExpectedThroughput=500", "True", "True"),
     ("wifi-eht-network --simulationTime=0.1 --frequency=2.4 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=212", "True", "True"),
-    ("wifi-eht-network --simulationTime=0.2 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=4 --frequency2=6  --minExpectedThroughput=35 --maxExpectedThroughput=280", "True", "True"),
+    ("wifi-eht-network --simulationTime=0.22 --udp=0 --downlink=1 --useRts=0 --nStations=4 --dlAckType=ACK-SU-FORMAT --enableUlOfdma=1 --enableBsrp=0 --mcs=4 --frequency2=6  --minExpectedThroughput=35 --maxExpectedThroughput=280", "True", "True"),
     ("wifi-eht-network --simulationTime=0.25 --frequency=2.4 --udp=0 --downlink=1 --useRts=0 --nStations=5 --dlAckType=MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --frequency2=5 --useExtendedBlockAck=1 --minExpectedThroughput=40 --maxExpectedThroughput=100", "True", "True"),
     ("wifi-eht-network --simulationTime=0.3 --udp=0 --downlink=1 --useRts=1 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=0 --mcs=6 --muSchedAccessReqInterval=50ms --frequency2=2.4 --minExpectedThroughput=50 --maxExpectedThroughput=140", "True", "True"),
     ("wifi-eht-network --simulationTime=0.2 --udp=1 --downlink=0 --useRts=0 --nStations=5 --dlAckType=AGGR-MU-BAR --enableUlOfdma=1 --enableBsrp=1 --mcs=5 --muSchedAccessReqInterval=50ms --frequency2=6 --minExpectedThroughput=70 --maxExpectedThroughput=715", "True", "True"),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/mixed-wired-wireless.cc ns-3.39/examples/wireless/mixed-wired-wireless.cc
--- ns-3.38/examples/wireless/mixed-wired-wireless.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/mixed-wired-wireless.cc	2023-07-05 14:23:47.669427000 -0700
@@ -414,7 +414,7 @@
     // pcap trace on the application data sink
     wifiPhy.EnablePcap("mixed-wireless", appSink->GetId(), 0);
 
-    if (useCourseChangeCallback == true)
+    if (useCourseChangeCallback)
     {
         Config::Connect("/NodeList/*/$ns3::MobilityModel/CourseChange",
                         MakeCallback(&CourseChangeCallback));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/mixed-wired-wireless.py ns-3.39/examples/wireless/mixed-wired-wireless.py
--- ns-3.38/examples/wireless/mixed-wired-wireless.py	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/mixed-wired-wireless.py	2023-07-05 14:23:47.669427000 -0700
@@ -91,7 +91,7 @@
     cmd.AddValue("backboneNodes", "number of backbone nodes", backboneNodes)
     cmd.AddValue("infraNodes", "number of leaf nodes", infraNodes)
     cmd.AddValue("lanNodes", "number of LAN nodes", lanNodes)
-    cmd.AddValue("stopTime", "simulation stop time(seconds)", stopTime)
+    cmd.AddValue["double"]("stopTime", "simulation stop time(seconds)", stopTime)
 
     #
     #  The system global variables and the local values added to the argument
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-adhoc.cc ns-3.39/examples/wireless/wifi-adhoc.cc
--- ns-3.38/examples/wireless/wifi-adhoc.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-adhoc.cc	2023-07-05 14:23:47.669427000 -0700
@@ -175,8 +175,7 @@
     YansWifiPhyHelper phy = wifiPhy;
     phy.SetChannel(wifiChannel.Create());
 
-    WifiMacHelper mac = wifiMac;
-    NetDeviceContainer devices = wifi.Install(phy, mac, c);
+    NetDeviceContainer devices = wifi.Install(phy, wifiMac, c);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-clear-channel-cmu.cc ns-3.39/examples/wireless/wifi-clear-channel-cmu.cc
--- ns-3.38/examples/wireless/wifi-clear-channel-cmu.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-clear-channel-cmu.cc	2023-07-05 14:23:47.669427000 -0700
@@ -183,8 +183,7 @@
     YansWifiPhyHelper phy = wifiPhy;
     phy.SetChannel(wifiChannel.Create());
 
-    WifiMacHelper mac = wifiMac;
-    NetDeviceContainer devices = wifi.Install(phy, mac, c);
+    NetDeviceContainer devices = wifi.Install(phy, wifiMac, c);
 
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-eht-network.cc ns-3.39/examples/wireless/wifi-eht-network.cc
--- ns-3.38/examples/wireless/wifi-eht-network.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-eht-network.cc	2023-07-05 14:23:47.669427000 -0700
@@ -1,4 +1,3 @@
-/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
 /*
  * Copyright (c) 2022
  *
@@ -244,11 +243,8 @@
                      "AGGR-MU-BAR)");
     }
 
-    double prevThroughput[12];
-    for (uint32_t l = 0; l < 12; l++)
-    {
-        prevThroughput[l] = 0;
-    }
+    double prevThroughput[12] = {0};
+
     std::cout << "MCS value"
               << "\t\t"
               << "Channel width"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-he-network.cc ns-3.39/examples/wireless/wifi-he-network.cc
--- ns-3.38/examples/wireless/wifi-he-network.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-he-network.cc	2023-07-05 14:23:47.669427000 -0700
@@ -167,11 +167,8 @@
         phyModel = "Spectrum";
     }
 
-    double prevThroughput[12];
-    for (uint32_t l = 0; l < 12; l++)
-    {
-        prevThroughput[l] = 0;
-    }
+    double prevThroughput[12] = {0};
+
     std::cout << "MCS value"
               << "\t\t"
               << "Channel width"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-ht-network.cc ns-3.39/examples/wireless/wifi-ht-network.cc
--- ns-3.38/examples/wireless/wifi-ht-network.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-ht-network.cc	2023-07-05 14:23:47.669427000 -0700
@@ -96,11 +96,8 @@
         Config::SetDefault("ns3::WifiRemoteStationManager::RtsCtsThreshold", StringValue("0"));
     }
 
-    double prevThroughput[8];
-    for (uint32_t l = 0; l < 8; l++)
-    {
-        prevThroughput[l] = 0;
-    }
+    double prevThroughput[8] = {0};
+
     std::cout << "MCS value"
               << "\t\t"
               << "Channel width"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/examples/wireless/wifi-multirate.cc ns-3.39/examples/wireless/wifi-multirate.cc
--- ns-3.38/examples/wireless/wifi-multirate.cc	2023-03-16 20:54:23.572868300 -0700
+++ ns-3.39/examples/wireless/wifi-multirate.cc	2023-07-05 14:23:47.669427000 -0700
@@ -505,8 +505,7 @@
     YansWifiPhyHelper phy = wifiPhy;
     phy.SetChannel(wifiChannel.Create());
 
-    WifiMacHelper mac = wifiMac;
-    NetDeviceContainer devices = wifi.Install(phy, mac, c);
+    NetDeviceContainer devices = wifi.Install(phy, wifiMac, c);
 
     OlsrHelper olsr;
     Ipv4StaticRoutingHelper staticRouting;
